//This code is based on Circuit 2 of the USK Guide Code
//First we create variables named sensorpin, blue, red and green.
//They are of the type "int"

const int sensorpin = 3; //Phototransistor is connected to analog pin 2
const int bluePin = 2; //The RGB led is connected to these pins.
const int redPin = 1;
const int greenPin = 0;


//Since the variables are not in a function, they are "global variables".
//All functions can see them. This can muddle things, but is okay for now.

void setup() {
  // put your setup code here, to run once:
pinMode(bluePin, OUTPUT);
pinMode(redPin, OUTPUT);
pinMode(greenPin, OUTPUT); 
}
//I do not have to configure my 
//phototransistor, since pin 2 is already an
//"analog in" pin.
void loop()
{
int  sensorValue = analogRead(sensorpin);
  if (sensorValue >=700) 
  {
      showSpectrum();

  delay(1000);
  }
   
  else 
  {
   // off

  digitalWrite(redPin, HIGH);
  digitalWrite(greenPin, HIGH);
  digitalWrite(bluePin, HIGH);

  delay(1000);
    
  }
}
void showSpectrum()
{
  int x;  // define an integer variable called "x"
  
  // Now we'll use a for() loop to make x count from 0 to 767
  // (Note that there's no semicolon after this line!
  // That's because the for() loop will repeat the next
  // "statement", which in this case is everything within
  // the following brackets {} )

  for (x = 0; x < 768; x++)

  // Each time we loop (with a new value of x), do the following:

  {
    showRGB(x);  // Call RGBspectrum() with our new x
    delay(10);   // Delay for 10 ms (1/100th of a second)
  }
}


// showRGB()

// This function translates a number between 0 and 767 into a
// specific color on the RGB LED. If you have this number count
// through the whole range (0 to 767), the LED will smoothly
// change color through the entire spectrum.

// The "base" numbers are:
// 0   = pure red 
// 255 = pure green
// 511 = pure blue
// 767 = pure red (again)

// Numbers between the above colors will create blends. For
// example, 640 is midway between 512 (pure blue) and 767
// (pure red). It will give you a 50/50 mix of blue and red,
// resulting in purple.

// If you count up from 0 to 767 and pass that number to this
// function, the LED will smoothly fade between all the colors.
// (Because it starts and ends on pure red, you can start over
// at 0 without any break in the spectrum).


void showRGB(int x)
{
  int redIntensity;
  int greenIntensity;
  int blueIntensity;

  if (x <= 255)          // zone 1
  {
    redIntensity = x;               // red goes from on to off (from 0 to 255)
    greenIntensity = 255-x;         // green goes from off to on (from 255 to 0)
    blueIntensity = 255;            // blue is always off (always 255)
  }
  else if (x <= 511)     // zone 2
  {
    redIntensity = 255;                     // red is always off (always 255)
    greenIntensity = x - 256;               // green on to off (from 0 to 255)
    blueIntensity = 255 - (x - 256);        // blue off to on (from 255 to 0)
  }
  else // x >= 512       // zone 3
  {
    redIntensity = 255 - (x - 512);         // red off to on (from 255 to 0)
    greenIntensity = 255;                   // green is always off (always 255)
    blueIntensity = x - 512;                // blue on to off (from 0 to 255)
  }


  analogWrite(redPin, redIntensity);
  analogWrite(bluePin, blueIntensity);
  analogWrite(greenPin, greenIntensity);
}

